Summary:	Dictionary database server
Summary(pl.UTF-8):	Serwer bazy słowników
Name:		dictd
Version:	1.13.3
Release:	1
License:	GPL v1+
Group:		Networking/Daemons
Source0:	http://downloads.sourceforge.net/dict/%{name}-%{version}.tar.gz
# Source0-md5:	bb2f50bcf6d0a34b745d40649a4c0840
Source1:	%{name}.init
Source2:	%{name}.sysconfig
Patch0:		%{name}-umask.patch
Patch1:		%{name}-link.patch
URL:		http://dict.org/
BuildRequires:	autoconf >= 2.53
BuildRequires:	automake
BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	judy-devel
BuildRequires:	libdbi-devel
BuildRequires:	libmaa-devel
BuildRequires:	perl-base
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	zlib-devel
Requires(post,preun):	/sbin/chkconfig
Requires:	rc-scripts
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		skip_post_check_so	dictdplugin_judy.so.*

# plugins dir: shared modules, so use private dir in %{_libdir}, not %{_libexecdir}
%define		pkglibdir	%{_libdir}/dictd

%define		specflags_ia32	 -fomit-frame-pointer

%description
Server for the Dictionary Server Protocol (DICT), a TCP transaction
based query/response protocol that allows a client to access
dictionary definitions from a set of natural language dictionary
databases.

%description -l pl.UTF-8
Serwer dla Dictionary Server Protocol (DICT), bazującego na TCP
protokołu zapytań i odpowiedzi umożliwiającego klientom na dostęp do
definicji słownikowych z zestawu baz danych.

%package devel
Summary:	Package for dictd plugins development
Summary(pl.UTF-8):	Pakiet programistyczny do tworzenia wtyczek dictd
Group:		Development/Libraries
# doesn't require base

%description devel
Package for dictd plugins development.

%description devel -l pl.UTF-8
Pakiet programistyczny do tworzenia wtyczek dictd.

%package plugin-dbi
Summary:	DBI plugin for dictd server
Summary(pl.UTF-8):	Wtyczka DBI dla serwera dictd
Group:		Libraries
Requires:	%{name} = %{version}-%{release}

%description plugin-dbi
DBI plugin for dictd server.

%description plugin-dbi -l pl.UTF-8
Wtyczka DBI dla serwera dictd.

%package plugin-judy
Summary:	Judy plugin for dictd server
Summary(pl.UTF-8):	Wtyczka Judy dla serwera dictd
Group:		Libraries
Requires:	%{name} = %{version}-%{release}

%description plugin-judy
Judy plugin for dictd server.

%description plugin-judy -l pl.UTF-8
Wtyczka Judy dla serwera dictd.

%package -n dict
Summary:	DICT Protocol Client
Summary(pl.UTF-8):	Klient protokołu DICT
Group:		Applications/Networking

%description -n dict
Client for the Dictionary Server Protocol (DICT), a TCP transaction
based query/response protocol that provides access to dictionary
definitions from a set of natural language dictionary databases.

%description -n dict -l pl.UTF-8
Klient dla Dictionary Server Protocol (DICT), bazującego na TCP
protokołu zapytań i odpowiedzi umożliwiającego klientom na dostęp do
definicji słownikowych z zestawu baz danych.

%package -n dictfmt
Summary:	dictfmt utility to convert databases in various formats into dict format
Summary(pl.UTF-8):	Narzędzie dictfmt do konwersji baz w różnych formatach na format dict
Group:		Applications/Text
Obsoletes:	dict-fmt

%description -n dictfmt
dictfmt utility is designed to convert databases in various formats
into working databases and indexes for the DICT server. This package
also includes other tools for formating databases:
dictfmt_{index2suffix,index2word,plugin,virtual} and dictunformat.

%description -n dictfmt -l pl.UTF-8
Narzędzie dictfmt służy do konwertowania baz danych w różnych
formatach na działające bazy danych i indeksy dla serwera słowników
DICT. Ten pakiet zawiera także inne narzędzia do formatowania baz:
dictfmt_{index2suffix,index2word,plugin,virtual} and dictunformat.

%package -n dictzip
Summary:	Compress (or expand) files, allowing random access
Summary(pl.UTF-8):	Kompresja (i dekompresja) plików pozwalająca na swobodny dostęp
Group:		Applications/Archiving

%description -n dictzip
dictzip compresses files using the gzip(1) algorithm (LZ77) in a
manner which is completely compatible with the gzip file format. An
extension to the gzip file format (Extra Field, described in 2.3.1.1
of RFC 1952) allows extra data to be stored in the header of a
compressed file. Dictd, the DICT protocol dictionary server will make
use of this data to perform pseudo-random access on the file.

%description -n dictzip -l pl.UTF-8
dictzip kompresuje pliki korzystając z zawartego w gzip(1) algorytmu
(LZ77) który jest całkowicie kompatybilny z formatem plików gzip.
Rozszerzenie do formatu plików gzip (pole dodatkowe, opisane w 2.3.1.1
RFC 1952) pozwalającego na dodatkowe dane zapisane w nagłówku
skompresowanego pliku. Dictd, serwer protokołu DICT wykorzystuje te
dane do pseudo-swobodnego dostępu do pliku.

%prep
%setup -q
%patch -P0 -p1
%patch -P1 -p1

%build
cp -f /usr/share/automake/config.* .
%{__aclocal}
%{__autoconf}
CFLAGS="%{rpmcflags} -DUID_NOBODY=99 -DGID_NOBODY=99"
%configure \
	--libexecdir=%{pkglibdir} \
	--with-plugin-dbi \
	--with-plugin-judy

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/etc/{rc.d/init.d,sysconfig},%{_sysconfdir}/%{name},%{_datadir}/%{name}}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

echo "server localhost" > dict.conf
echo -e "access {\n\tallow localhost\n\tdeny *\n}\n" > %{name}-main.conf

install dict.conf $RPM_BUILD_ROOT%{_sysconfdir}
install dictd-main.conf $RPM_BUILD_ROOT%{_sysconfdir}/%{name}
:> $RPM_BUILD_ROOT%{_sysconfdir}/%{name}.conf
install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
install %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/%{name}

%{__rm} $RPM_BUILD_ROOT%{pkglibdir}/dictdplugin_*.{la,a}

%{__mv} doc/security.doc security.txt

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add %{name}
%service dictd restart

%preun
if [ "$1" = "0" ]; then
	%service dictd stop
	/sbin/chkconfig --del %{name}
fi

%files
%defattr(644,root,root,755)
%doc ANNOUNCE NEWS README TODO examples/dictd*.conf security.txt
%ghost %{_sysconfdir}/%{name}.conf
%dir %{_sysconfdir}/%{name}
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/%{name}/%{name}-main.conf
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/dictd
%attr(754,root,root) /etc/rc.d/init.d/dictd
%attr(755,root,root) %{_sbindir}/dictd
%dir %{_datadir}/%{name}
%dir %{pkglibdir}
%{_mandir}/man8/dictd.8*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/dictdplugin-config
%{_includedir}/dictdplugin.h

%files plugin-dbi
%defattr(644,root,root,755)
%attr(755,root,root) %{pkglibdir}/dictdplugin_dbi.so*

%files plugin-judy
%defattr(644,root,root,755)
%attr(755,root,root) %{pkglibdir}/dictdplugin_judy.so*

%files -n dict
%defattr(644,root,root,755)
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/dict.conf
%attr(755,root,root) %{_bindir}/colorit
%attr(755,root,root) %{_bindir}/dict
%attr(755,root,root) %{_bindir}/dictl
%attr(755,root,root) %{_bindir}/dict_lookup
%{_mandir}/man1/colorit.1*
%{_mandir}/man1/dict.1*
%{_mandir}/man1/dictl.1*
%{_mandir}/man1/dict_lookup.1*

%files -n dictfmt
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/dictfmt*
%attr(755,root,root) %{_bindir}/dictunformat
%{_mandir}/man1/dictfmt*.1*
%{_mandir}/man1/dictunformat.1*

%files -n dictzip
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/dictzip
%{_mandir}/man1/dictzip.1*
%changelog
* Sun Apr 06 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/dictd.git;a=log;h=master

* Sun Apr 06 2025 Jakub Bogusz <qboosh@pld-linux.org> 2b8eebb
- updated to 1.13.3

* Tue Feb 18 2025 Jakub Bogusz <qboosh@pld-linux.org> 79ed05a
- use patch -P

* Fri Mar 20 2015 Elan Ruusamäe <glen@delfi.ee> 526cb4a
- x32 rebuild
- release 2 (by relup.sh)

* Mon Jan 06 2014 Jakub Bogusz <qboosh@pld-linux.org> 8f564cb
- updated to 1.12.1

* Wed Aug 31 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> 3087c25
- release 2

* Mon Jan 10 2011 Jakub Bogusz <qboosh@pld-linux.org> 0c3fa3a
- updated to 1.12.0

* Thu Nov 25 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 774d121
- rel 3

* Thu Nov 25 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> d34235d
- rel 2; skip checking symbols for skip_post_check_so

* Thu Nov 25 2010 Arkadiusz Miśkiewicz <arekm@maven.pl> 98f01ab
- release 2

* Sun Nov 14 2010 Jakub Bogusz <qboosh@pld-linux.org> 8ef4f98
- updated to 1.11.2
- updated umask patch, removed obsolete opt patch
- relies on system libmaa now

* Mon Mar 12 2007 Elan Ruusamäe <glen@pld-linux.org> 4b37467
- update to 1.10.4

* Mon Mar 12 2007 Elan Ruusamäe <glen@pld-linux.org> 6319e51
- umask patch from AC-branch

* Mon Mar 12 2007 Elan Ruusamäe <glen@pld-linux.org> b823e60
- rel 2 (use %service)

* Mon Feb 12 2007 Elan Ruusamäe <glen@pld-linux.org> e64a8f9
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> b6759d8
- converted to UTF-8

* Wed May 10 2006 radek <radek@pld-linux.org> 03230a1
- version 1.10.4 (SECURITY update: fixes DoS)

* Wed May 10 2006 radek <radek@pld-linux.org> a8d3b52
- umask 077 instead of 0

* Thu Dec 08 2005 Elan Ruusamäe <glen@pld-linux.org> 639b827
- killed trailing spaces/tabs

* Sun Dec 04 2005 Elan Ruusamäe <glen@pld-linux.org> 2bd6bc4
- adapterized (sorted %verify flags)

* Tue Nov 22 2005 Elan Ruusamäe <glen@pld-linux.org> a27bdc2
- full R: chkconfig; rel 2

